diff --git a/isisd/isis_srv6.c b/isisd/isis_srv6.c
index c524f5c16969..0b6ef5d67004 100644
--- a/isisd/isis_srv6.c
+++ b/isisd/isis_srv6.c
@@ -36,6 +36,29 @@
 /* Local variables and functions */
 DEFINE_MTYPE_STATIC(ISISD, ISIS_SRV6_SID, "ISIS SRv6 Segment ID");
 
+/**
+ * Fill in SRv6 SID Structure Sub-Sub-TLV with information from an SRv6 SID
+ *
+ * @param sid				    SRv6 SID configuration
+ * @param structure_subsubtlv	SRv6 SID Structure Sub-Sub-TLV to be updated
+ */
+void isis_srv6_sid_structure2subsubtlv(
+	const struct isis_srv6_sid *sid,
+	struct isis_srv6_sid_structure_subsubtlv *structure_subsubtlv)
+{
+	/* Set Locator Block length */
+	structure_subsubtlv->loc_block_len = sid->structure.loc_block_len;
+
+	/* Set Locator Node length */
+	structure_subsubtlv->loc_node_len = sid->structure.loc_node_len;
+
+	/* Set Function length */
+	structure_subsubtlv->func_len = sid->structure.func_len;
+
+	/* Set Argument length */
+	structure_subsubtlv->arg_len = sid->structure.arg_len;
+}
+
 /**
  * Fill in SRv6 End SID Sub-TLV with information from an SRv6 End SID.
  *
diff --git a/isisd/isis_srv6.h b/isisd/isis_srv6.h
index cd67b5b1a457..2653c8bf8826 100644
--- a/isisd/isis_srv6.h
+++ b/isisd/isis_srv6.h
@@ -120,5 +120,8 @@ void isis_srv6_locator2tlv(const struct isis_srv6_locator *loc,
 			   struct isis_srv6_locator_tlv *loc_tlv);
 void isis_srv6_end_sid2subtlv(const struct isis_srv6_sid *sid,
 			      struct isis_srv6_end_sid_subtlv *sid_subtlv);
+void isis_srv6_sid_structure2subsubtlv(
+	const struct isis_srv6_sid *sid,
+	struct isis_srv6_sid_structure_subsubtlv *structure_subsubtlv);
 
 #endif /* _FRR_ISIS_SRV6_H */
